

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>SmartRecruiting_BackEnd.deeplearning.cnn.Model &mdash; SmartRecruiting back v2 documentation</title>
  

  
  
  
  

  
  <script type="text/javascript" src="../../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../../" src="../../../../_static/documentation_options.js"></script>
        <script type="text/javascript" src="../../../../_static/jquery.js"></script>
        <script type="text/javascript" src="../../../../_static/underscore.js"></script>
        <script type="text/javascript" src="../../../../_static/doctools.js"></script>
        <script type="text/javascript" src="../../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../../index.html" class="icon icon-home"> SmartRecruiting back
          

          
          </a>

          
            
            
              <div class="version">
                v2
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../install.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../contributing.html">Contributing</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../documentation.html">Backend documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">SmartRecruiting back</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
        
      <li>SmartRecruiting_BackEnd.deeplearning.cnn.Model</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for SmartRecruiting_BackEnd.deeplearning.cnn.Model</h1><div class="highlight"><pre>
<span></span><span class="ch">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># License : GNU General Public License</span>
<span class="c1"># Authors: Romain Guillot</span>
<span class="kn">import</span> <span class="nn">tensorflow</span> <span class="k">as</span> <span class="nn">tf</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>

<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd</span> <span class="k">import</span> <span class="n">get_path</span>
<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd.deeplearning.preprocess</span> <span class="k">import</span> <span class="n">preprocess</span>
<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd.deeplearning.utils</span> <span class="k">import</span> <span class="n">ModelInitialisationError</span>
<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd.deeplearning.utils</span> <span class="k">import</span> <span class="n">log</span><span class="p">,</span> <span class="n">success</span>

<div class="viewcode-block" id="Model"><a class="viewcode-back" href="../../../../backend_doc/cnn.html#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model">[docs]</a><span class="k">class</span> <span class="nc">Model</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Handle a Keras model. Several public methods (see method documentation to know more how to use) :</span>

<span class="sd">    * load : load the model from the directory [save_dirname]</span>
<span class="sd">    * build : generate the Keras model structure (layers)</span>
<span class="sd">    * train : train the Keras model</span>
<span class="sd">    * eval : eval the Keras model</span>
<span class="sd">    * predict : generate predictions for an offer</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">save_dirname</span><span class="p">,</span> <span class="n">word2vec</span><span class="p">,</span> <span class="n">epochs</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Init an object containing mainly a keras model to train, eval and predict.</span>

<span class="sd">        :param save_dirname: directory where to save / load the Keras model</span>
<span class="sd">        :type save_dirname: str</span>

<span class="sd">        :param word2vec: Word2vec model (preprocessing model, see preprocess.py to know more about this model)</span>
<span class="sd">        :type word2vec: Word2Vec</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">save_dirname</span> <span class="o">=</span> <span class="n">save_dirname</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>  <span class="c1"># Clean directory path</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">w2v_model</span> <span class="o">=</span> <span class="n">word2vec</span>

        <span class="c1"># Following parameters will be init with the _build method</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">word_index</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">embedding_matrix</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">model</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">epochs</span> <span class="o">=</span> <span class="n">epochs</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">_generate_word_index</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_generate_embedding_matrix</span><span class="p">()</span>

        <span class="c1"># Remove the last to normalize dirname</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">save_dirname</span><span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">save_dirname</span><span class="p">)</span> <span class="o">-</span> <span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;/&quot;</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">save_dirname</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">save_dirname</span><span class="p">[:</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">save_dirname</span><span class="p">)</span> <span class="o">-</span> <span class="mi">1</span><span class="p">]</span>

    <span class="c1">####################################################################################################################</span>
    <span class="c1"># Public methods   #################################################################################################</span>
    <span class="c1">####################################################################################################################</span>
<div class="viewcode-block" id="Model.load"><a class="viewcode-back" href="../../../../backend_doc/cnn.html#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.load">[docs]</a>    <span class="k">def</span> <span class="nf">load</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Load the model (and so init the model parameter) from the specified directory (see class parameters)</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">model</span> <span class="o">=</span> <span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">models</span><span class="o">.</span><span class="n">load_model</span><span class="p">(</span><span class="n">get_path</span><span class="p">(</span><span class="s2">&quot;/data/model/final_model.h5&quot;</span><span class="p">))</span></div>

<div class="viewcode-block" id="Model.build"><a class="viewcode-back" href="../../../../backend_doc/cnn.html#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.build">[docs]</a>    <span class="k">def</span> <span class="nf">build</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">number_of_labels</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Build the Keras model structure (define the layers in our model)</span>
<span class="sd">        It&#39;s a multi-class classification, so the output are defined by [number_of_labels] parameter.</span>

<span class="sd">        .. warning::</span>
<span class="sd">           It&#39;s probably the most important methods to change to improve the model.</span>
<span class="sd">           The most &quot;difficult&quot; part is to find which layers to use and define layers parameters.</span>

<span class="sd">        :param number_of_labels:  output dimensions,</span>
<span class="sd">        :type number_of_labels: int</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">log</span><span class="p">(</span><span class="s2">&quot;Build model...&quot;</span><span class="p">)</span>
        <span class="n">model</span> <span class="o">=</span> <span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">Sequential</span><span class="p">()</span>
        <span class="n">model</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">layers</span><span class="o">.</span><span class="n">Embedding</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">word_index</span><span class="p">)</span> <span class="o">+</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">100</span><span class="p">,</span> <span class="n">weights</span><span class="o">=</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">embedding_matrix</span><span class="p">],</span> <span class="n">input_length</span><span class="o">=</span><span class="mi">400</span><span class="p">,</span> <span class="n">trainable</span><span class="o">=</span><span class="kc">False</span><span class="p">))</span>
        <span class="n">model</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">layers</span><span class="o">.</span><span class="n">Dropout</span><span class="p">(</span><span class="mf">0.1</span><span class="p">))</span>
        <span class="n">model</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">layers</span><span class="o">.</span><span class="n">Conv1D</span><span class="p">(</span><span class="mi">300</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="n">padding</span><span class="o">=</span><span class="s1">&#39;valid&#39;</span><span class="p">,</span> <span class="n">activation</span><span class="o">=</span><span class="s1">&#39;relu&#39;</span><span class="p">,</span> <span class="n">strides</span><span class="o">=</span><span class="mi">1</span><span class="p">))</span>
        <span class="n">model</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">layers</span><span class="o">.</span><span class="n">GlobalMaxPool1D</span><span class="p">())</span>
        <span class="n">model</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">layers</span><span class="o">.</span><span class="n">Dense</span><span class="p">(</span><span class="n">number_of_labels</span><span class="p">))</span>
        <span class="n">model</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">layers</span><span class="o">.</span><span class="n">Activation</span><span class="p">(</span><span class="s1">&#39;sigmoid&#39;</span><span class="p">))</span>

        <span class="n">model</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="n">loss</span><span class="o">=</span><span class="s1">&#39;binary_crossentropy&#39;</span><span class="p">,</span> <span class="n">optimizer</span><span class="o">=</span><span class="s1">&#39;adam&#39;</span><span class="p">,</span> <span class="n">metrics</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;accuracy&#39;</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">model</span> <span class="o">=</span> <span class="n">model</span>
        <span class="n">success</span><span class="p">(</span><span class="s2">&quot;Build model : successful&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="Model.train"><a class="viewcode-back" href="../../../../backend_doc/cnn.html#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.train">[docs]</a>    <span class="k">def</span> <span class="nf">train</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">features</span><span class="p">,</span> <span class="n">labels</span><span class="p">,</span> <span class="n">save</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Train the Keras model with [features] and [label].</span>

<span class="sd">        :param features: features on which train the model</span>
<span class="sd">        :type features: list of str</span>

<span class="sd">        :param labels: array of hot vector that represent formation associated with features</span>
<span class="sd">                        So array of the same size of features lists. And each element is an hot vector</span>
<span class="sd">        :type labels: numpy array of numpy array of int (0 or 1)</span>

<span class="sd">        :param save: set to True to save the model (saved in the directory specify in the class parameters)</span>
<span class="sd">        :type save: bool</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">log</span><span class="p">(</span><span class="s2">&quot;Train model...&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">ModelInitialisationError</span><span class="p">(</span><span class="s2">&quot;Model not build. Consider using build (and train) or load methods before.&quot;</span><span class="p">)</span>

        <span class="n">save_filename</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">save_dirname</span> <span class="o">+</span> <span class="s2">&quot;/save_checkpoint_</span><span class="si">{epoch:03d}</span><span class="s2">.h5&quot;</span>

        <span class="n">features</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_text_to_word_indexes</span><span class="p">(</span><span class="n">features</span><span class="p">)</span>
        <span class="n">features</span> <span class="o">=</span> <span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">preprocessing</span><span class="o">.</span><span class="n">sequence</span><span class="o">.</span><span class="n">pad_sequences</span><span class="p">(</span><span class="n">features</span><span class="p">,</span> <span class="n">maxlen</span><span class="o">=</span><span class="mi">400</span><span class="p">,</span> <span class="n">padding</span><span class="o">=</span><span class="s2">&quot;post&quot;</span><span class="p">)</span>
        <span class="n">callbacks</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">if</span> <span class="n">save</span><span class="p">:</span>
            <span class="n">callbacks</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">callbacks</span><span class="o">.</span><span class="n">ModelCheckpoint</span><span class="p">(</span><span class="n">save_filename</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">period</span><span class="o">=</span><span class="mi">2</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">fit</span><span class="p">(</span><span class="n">features</span><span class="p">,</span> <span class="n">labels</span><span class="p">,</span> <span class="n">epochs</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">epochs</span><span class="p">,</span> <span class="n">callbacks</span><span class="o">=</span><span class="n">callbacks</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">save</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="s2">&quot;./data/model/final_model.h5&quot;</span><span class="p">)</span>
        <span class="n">success</span><span class="p">(</span><span class="s2">&quot;Train model : successful&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="Model.eval"><a class="viewcode-back" href="../../../../backend_doc/cnn.html#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.eval">[docs]</a>    <span class="k">def</span> <span class="nf">eval</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">features</span><span class="p">,</span> <span class="n">labels</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Eval the accuracy and the loss of our model with [features] (and check the results with [labels]</span>

<span class="sd">        :param features: features on which evaluate the model</span>
<span class="sd">        :type features: list of str</span>

<span class="sd">        :param labels: array of hot vector that represent formation associated with features</span>
<span class="sd">                        So array of the same size of features lists. And each element is an hot vector</span>
<span class="sd">        :type labels: numpy array of numpy array of int (0 or 1)</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">log</span><span class="p">(</span><span class="s2">&quot;Eval model...&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">ModelInitialisationError</span><span class="p">(</span><span class="s2">&quot;Model not build. Consider using build (and train) or load methods before.&quot;</span><span class="p">)</span>

        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Eval on &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">features</span><span class="p">))</span> <span class="o">+</span> <span class="s2">&quot; offers&quot;</span><span class="p">)</span>
        <span class="n">features</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_text_to_word_indexes</span><span class="p">(</span><span class="n">features</span><span class="p">)</span>
        <span class="n">features</span> <span class="o">=</span> <span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">preprocessing</span><span class="o">.</span><span class="n">sequence</span><span class="o">.</span><span class="n">pad_sequences</span><span class="p">(</span><span class="n">features</span><span class="p">,</span> <span class="n">maxlen</span><span class="o">=</span><span class="mi">400</span><span class="p">,</span> <span class="n">padding</span><span class="o">=</span><span class="s2">&quot;post&quot;</span><span class="p">)</span>
        <span class="n">loss</span><span class="p">,</span> <span class="n">acc</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">evaluate</span><span class="p">(</span><span class="n">features</span><span class="p">,</span> <span class="n">labels</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Test Accuracy: </span><span class="si">%f</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">acc</span> <span class="o">*</span> <span class="mi">100</span><span class="p">))</span>
        <span class="n">success</span><span class="p">(</span><span class="s2">&quot;Eval model : successful&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="Model.predict"><a class="viewcode-back" href="../../../../backend_doc/cnn.html#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.predict">[docs]</a>    <span class="k">def</span> <span class="nf">predict</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">feature</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Predict formations of the [feature]</span>

<span class="sd">        :param feature: offer to predict</span>
<span class="sd">        :type feature: str</span>

<span class="sd">        :return: dictionary of prediction {id_prediction: accuracy of the formation (mark)}</span>
<span class="sd">        :rtype: dict {int : int}</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">log</span><span class="p">(</span><span class="s2">&quot;Predict feature ...&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">ModelInitialisationError</span><span class="p">(</span><span class="s2">&quot;Model not build. Consider using build (and train) or load methods before.&quot;</span><span class="p">)</span>

        <span class="n">feature</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_text_to_word_indexes</span><span class="p">([</span><span class="n">feature</span><span class="p">])</span>
        <span class="n">feature</span> <span class="o">=</span> <span class="n">tf</span><span class="o">.</span><span class="n">keras</span><span class="o">.</span><span class="n">preprocessing</span><span class="o">.</span><span class="n">sequence</span><span class="o">.</span><span class="n">pad_sequences</span><span class="p">(</span><span class="n">feature</span><span class="p">,</span> <span class="n">maxlen</span><span class="o">=</span><span class="mi">400</span><span class="p">,</span> <span class="n">padding</span><span class="o">=</span><span class="s2">&quot;post&quot;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
        <span class="n">feature</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">expand_dims</span><span class="p">(</span><span class="n">feature</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>

        <span class="n">predictions</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">predict</span><span class="p">(</span><span class="n">feature</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
        <span class="n">res</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">prediction</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">predictions</span><span class="p">):</span>
            <span class="n">res</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">prediction</span>
        <span class="n">success</span><span class="p">(</span><span class="s2">&quot;Predict feature : successful&quot;</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">res</span></div>

    <span class="c1">####################################################################################################################</span>
    <span class="c1">#  Private methods   ###############################################################################################</span>
    <span class="c1">####################################################################################################################</span>
    <span class="k">def</span> <span class="nf">_generate_word_index</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Init work_index class parameter with Word2Vec model vocabulary.</span>
<span class="sd">        `word_index` is a dictionary that contains a word as key and an index as value</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">w2v_model</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">ModelInitialisationError</span><span class="p">(</span><span class="s2">&quot;Word2Vec model not found&quot;</span><span class="p">)</span>

        <span class="n">vocab</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">word</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">w2v_model</span><span class="o">.</span><span class="n">wv</span><span class="o">.</span><span class="n">vocab</span><span class="p">):</span>
            <span class="n">vocab</span><span class="p">[</span><span class="n">word</span><span class="p">]</span> <span class="o">=</span> <span class="n">i</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">word_index</span> <span class="o">=</span> <span class="n">vocab</span>

    <span class="k">def</span> <span class="nf">_generate_embedding_matrix</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Init embedding_matrix class parameter It contains</span>
<span class="sd">        There are a direct link with the word_index.</span>
<span class="sd">        The index store in the word_index dictionary for each word</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">word_index</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">ModelInitialisationError</span><span class="p">(</span><span class="s2">&quot;Word index not initialized.&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">w2v_model</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">ModelInitialisationError</span><span class="p">(</span><span class="s2">&quot;Word2Vec model not found.&quot;</span><span class="p">)</span>

        <span class="n">vocab_size</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">word_index</span><span class="p">)</span> <span class="o">+</span> <span class="mi">1</span>
        <span class="n">embedding_matrix</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">((</span><span class="n">vocab_size</span><span class="p">,</span> <span class="mi">100</span><span class="p">))</span>
        <span class="k">for</span> <span class="n">word</span><span class="p">,</span> <span class="n">index</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">word_index</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="n">embedding_matrix</span><span class="p">[</span><span class="n">index</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">w2v_model</span><span class="p">[</span><span class="n">word</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">embedding_matrix</span> <span class="o">=</span> <span class="n">embedding_matrix</span>

    <span class="k">def</span> <span class="nf">_text_to_word_indexes</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">texts</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Transform the [texts] to list of list of word descriptor</span>

<span class="sd">        :param texts: list of texts to transform</span>
<span class="sd">        :type texts: list of str</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">word_index</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">ModelInitialisationError</span><span class="p">(</span><span class="s2">&quot;Word index not initialized.&quot;</span><span class="p">)</span>

        <span class="n">texts_res</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">text</span> <span class="ow">in</span> <span class="n">texts</span><span class="p">:</span>
            <span class="n">text_res</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="n">text</span> <span class="o">=</span> <span class="n">preprocess</span><span class="o">.</span><span class="n">tokenize</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">word</span> <span class="ow">in</span> <span class="n">text</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">word</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">word_index</span><span class="p">:</span>
                    <span class="n">text_res</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">word_index</span><span class="p">[</span><span class="n">word</span><span class="p">])</span>
            <span class="n">texts_res</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">text_res</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">texts_res</span></div>
</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, Projet 21

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>